// DlgXmeter.cpp : implementation file
//

#include "stdafx.h"
#include "xMeter.h"
#include "DlgXmeter.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

UINT id1 = 0;
UINT id2 = 0;
bool st_ext = false;
int  db = 0;
bool type = false;
double data_min = 0.0;
double data_max = 100.0;
double data_scale = 1.0;

/////////////////////////////////////////////////////////////////////////////

BEGIN_MESSAGE_MAP(CDlgXMeterTab, CTabCtrl)
	//{{AFX_MSG_MAP(CDlgXMeterTab)
	ON_NOTIFY_REFLECT(TCN_SELCHANGE, OnSelChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////

CDlgXMeterTab::CDlgXMeterTab() : m_PreviousTab(0), m_MaxWidth(0), m_MaxHeight(0) 
{
	m_meter = new CDlgXMeterPage1(this);
	m_settings = new CDlgXMeterPage2(this);


	m_pDialogs[0] = m_meter;
	m_pDialogs[1] = m_settings;

	id1 = 0;
	id2 = 0;
	st_ext = false;
	db = 0;
	type = false;
	data_min = 0.0;
	data_max = 100.0;
	data_scale = 1.0;
}

void CDlgXMeterTab::PreSubclassWindow() {
	CRect DisplayArea;
	int i, n;
	CTabCtrl::PreSubclassWindow();
	m_Parent = GetParent();
	if (InsertItem(0, "Measure")==-1)
		MessageBox("InsertItem 0 failed");
	if (InsertItem(1, "Settings")==-1)
		MessageBox("InsertItem 1 failed");

	if (!CreateTab(m_pDialogs[0], IDD_PROPPAGE1, 0))		// initially visible and enabled
		MessageBox("Measure Dialog was not created");
	if (!CreateTab(m_pDialogs[1], IDD_PROPPAGE2, 1))		// initially hidden and disabled
		MessageBox("Settings Dialog was not created");


	SetCurSel(0);
	// get our position and size
	// GetWindowRect receives the screen coordinates of the corners.
	GetWindowRect(&DisplayArea);
	m_Parent->ScreenToClient(&DisplayArea);		// to our parent's coordinates
	AdjustRect(FALSE, &DisplayArea);		// Get current display area
	DisplayArea.right = m_MaxWidth + DisplayArea.left;
	DisplayArea.bottom = m_MaxHeight + DisplayArea.top;
	AdjustRect(TRUE, &DisplayArea);
	MoveWindow(&DisplayArea);		// resize ourself
	AdjustRect(FALSE, &DisplayArea);
	
	for (i=0,n=(sizeof m_pDialogs/sizeof m_pDialogs[0]);i<n;++i)
	{
		m_pDialogs[i]->MoveWindow(DisplayArea.left, DisplayArea.top,
			DisplayArea.Width(), DisplayArea.Height(), FALSE);
	}

	m_PreviousTab = GetCurSel();
	m_pDialogs[m_PreviousTab]->EnableWindow(TRUE);
	m_pDialogs[m_PreviousTab]->ShowWindow(SW_SHOW);
}

// Create the dialogs that are the tab control's contents.
// The parent must be the same parent as the tab control's.
// Therefore they will be repositioned later. Until
// then we gather the maximum sizes so the tab control can
// be adjusted in size so the tab dialogs will fit.
BOOL CDlgXMeterTab::CreateTab(CDialog *pDlg, UINT nId, int x) {
	CRect WindowRect;
	int tw, th;
	if (!pDlg->Create(nId, m_Parent))
		return FALSE;
	pDlg->GetWindowRect(&WindowRect);
	tw = WindowRect.Width();
	m_MaxWidth = tw < m_MaxWidth ? m_MaxWidth : tw;
	th = WindowRect.Height();
	m_MaxHeight = th < m_MaxHeight ? m_MaxHeight : th;
	return TRUE;
	}

	void CDlgXMeterTab::OnSelChange(NMHDR* pNMHDR, LRESULT* pResult) {
	*pResult = 0;
	if (m_PreviousTab == GetCurSel())
		return;
	//m_pDialogs[m_PreviousTab]->GetClientRect
	m_pDialogs[m_PreviousTab]->EnableWindow(FALSE);
	m_pDialogs[m_PreviousTab]->ShowWindow(SW_HIDE);

	m_PreviousTab = GetCurSel();
	m_pDialogs[m_PreviousTab]->EnableWindow(TRUE);
	m_pDialogs[m_PreviousTab]->ShowWindow(SW_SHOW);
}

/////////////////////////////////////////////////////////////////////////////
// CDlgXmeter dialog


CDlgXmeter::CDlgXmeter(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgXmeter::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgXmeter)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CDlgXmeter::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgXmeter)
	DDX_Control(pDX, IDC_TAB, m_tab);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgXmeter, CDialog)
	//{{AFX_MSG_MAP(CDlgXmeter)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgXmeter message handlers


BOOL CDlgXmeter::OnInitDialog() 
{
	CDialog::OnInitDialog();
	

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/*
void CDlgXmeter::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
//		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}
*/
void CDlgXmeter::OnClose() 
{
	demo_dialog = NULL;
	
	CDialog::OnClose();
}

void CDlgXmeter::ExtClose() 
{
	demo_dialog = NULL;
	
	CDialog::OnClose();
}
