// TabCANOpen2.cpp : implementation file
//

#include "stdafx.h"
#include "TabPage2.h"
#include "DlgXmeter.h"
#include "../../Lib/cfg/MsgFile.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgXMeterPage2 dialog


CDlgXMeterPage2::CDlgXMeterPage2(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgXMeterPage2::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgXMeterPage2)
	m_db = 0;
	m_type = FALSE;
	m_min = 0.0;
	m_max = 100.0;
	m_id1 = 0;
	m_id2 = 0;
	m_st_ext = FALSE;
	//}}AFX_DATA_INIT
}


void CDlgXMeterPage2::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgXMeterPage2)
	DDX_Radio(pDX, IDC_DB0, m_db);
	DDX_Check(pDX, IDC_TYPE, m_type);
	DDX_Text(pDX, IDC_MIN, m_min);
	DDX_Text(pDX, IDC_MAX, m_max);
	DDX_Text(pDX, IDC_ID1, m_id1);
	DDX_Text(pDX, IDC_ID2, m_id2);
	DDX_Check(pDX, IDC_ST_EXT, m_st_ext);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgXMeterPage2, CDialog)
	//{{AFX_MSG_MAP(CDlgXMeterPage2)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_LOAD, OnLoad)
	ON_BN_CLICKED(IDC_SET, OnSet)
	ON_BN_CLICKED(IDC_TYPE, OnType)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CDlgXMeterPage2::OnSave() 
{
	CFileDialog *dialog = new CFileDialog(false, "ppp");
	dialog->m_ofn.lpstrFilter = "Config files *.ppp\0*.PPP\0All files *.*\0*.*\0";
	if( dialog->DoModal() == IDOK ) {
		OnSet();
		cWConfigFile *config = new cWConfigFile();
		CString filename = dialog->GetPathName();
		config->set_name((char*)filename.GetBuffer(3));
		//int length;
		unsigned int  iValue;
		bool bValue;
		float dValue;
		iValue = m_db;
		config->WriteUInt("xMeter","db",iValue);
		iValue = m_id1;
		config->WriteUInt("xMeter","id1",iValue);
		iValue = m_id2;
		config->WriteUInt("xMeter","id2",iValue);

		bValue = (bool)m_type;
		config->WriteBool("xMeter","type",bValue);
		bValue = (bool)m_st_ext;
		config->WriteBool("xMeter","st_ext",bValue);

		dValue = (float)m_min;
 		config->WriteFloat("xMeter","min",dValue);
		dValue = (float)m_max;
 		config->WriteFloat("xMeter","max",dValue);
	}
}

void CDlgXMeterPage2::OnLoad() 
{
	CFileDialog *dialog = new CFileDialog(true, "ppp");
	dialog->m_ofn.lpstrFilter = "Config files *.ppp\0*.PPP\0All files *.*\0*.*\0";
	if( dialog->DoModal() == IDOK ) {
		cWConfigFile *config = new cWConfigFile();
		CString filename = dialog->GetPathName();
		config->set_name((char*)filename.GetBuffer(3));
		//int length;
		unsigned int  iValue;
		bool bValue;
		float dValue;
		config->ReadUInt("xMeter","db",&iValue,"0"); m_db = iValue;
		config->ReadUInt("xMeter","id1",&iValue,"0"); m_id1 = iValue;
		config->ReadUInt("xMeter","id2",&iValue,"0"); m_id2 = iValue;

		config->ReadBool("xMeter","type",&bValue,"0"); m_type = (BOOL)bValue;
		config->ReadBool("xMeter","st_ext",&bValue,"0"); m_st_ext = (BOOL)bValue;

		config->ReadFloat("xMeter","min",&dValue,"0"); m_min = dValue;
		config->ReadFloat("xMeter","max",&dValue,"100"); m_max = dValue;

		UpdateData(FALSE);
		OnSet();
	}
}

void CDlgXMeterPage2::OnSet() 
{
	UpdateData(TRUE);
	id1 = m_id1;
	id2 = m_id2;
	st_ext = (bool)m_st_ext;
	db = m_db;
	type = (bool)m_type;
	data_min = m_min;
	data_max = m_max;
	data_scale = 100.0/(m_max-m_min);	
}

void CDlgXMeterPage2::OnType() 
{
	UpdateData(TRUE);
	CWnd* pWnd;
	pWnd = GetDlgItem(IDC_DB7);
	if(m_type)		 pWnd->EnableWindow(FALSE);
	else			 pWnd->EnableWindow(TRUE);
}
